unit uFour1;

interface

PROCEDURE Four1(pData: Pointer; nn, isign: integer);

implementation

PROCEDURE Four1(pData: Pointer; nn, isign: integer);
type
  TDataType = Extended;
  TDataArray = array[1..High(Integer) div SizeOf(TDataType)] of TDataType;
  pTDataArray = ^TDataArray;
VAR
   ii,jj,n,mmax,m,j,istep,i: Integer;
   wtemp,wr,wpr,wpi,wi,theta,      //: double;
   tempr,tempi,wrs,wis: TDataType; //: real;
   data: pTDataArray;
BEGIN
   data:= pData;
   n := 2*nn;
   j := 1;
   FOR ii := 1 TO nn DO BEGIN
      i := 2*ii-1;
      IF j > i THEN BEGIN
         tempr := data[j];
         tempi := data[j+1];
         data[j] := data[i];
         data[j+1] := data[i+1];
         data[i] := tempr;
         data[i+1] := tempi
      END;
      m := n DIV 2;
      WHILE (m >= 2) AND (j > m) DO BEGIN
         j := j-m;
         m := m DIV 2
      END;
      j := j+m
   END;
   mmax := 2;
   WHILE n > mmax DO BEGIN
      istep := 2*mmax;
      theta := 2*Pi/(isign*mmax);
      wpr := -2.0*Sqr(sin(0.5*theta));
      wpi := Sin(theta);
      wr := 1.0;
      wi := 0.0;
      FOR ii := 1 TO mmax DIV 2 DO BEGIN
         m := 2*ii-1;
         wrs := wr;
         wis := wi;
         FOR jj := 0 TO (n-m) DIV istep DO BEGIN
            i := m + jj*istep;
            j := i+mmax;
            tempr := wrs*data[j]-wis*data[j+1];
            tempi := wrs*data[j+1]+wis*data[j];
            data[j] := data[i]-tempr;
            data[j+1] := data[i+1]-tempi;
            data[i] := data[i]+tempr;
            data[i+1] := data[i+1]+tempi
         END;
         wtemp := wr;
         wr := wr*wpr-wi*wpi+wr;
         wi := wi*wpr+wtemp*wpi+wi
      END;
      mmax := istep
   END
END;

end.
